//+------------------------------------------------------------------+
//|                                                  Heder.mq4       |
//|                                  2006 Sunwest3d                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "EA Heder by Sunwest3D  2006"


extern double SlowMA = 13;
extern double FastMA = 5;
extern double Shift  = 2;
extern double Lots=0.1;

extern double TakeProfit = 75;
extern double StopLoss= 50;
extern double TrailingStop= 50;

extern double Slippage = 3;
extern double TrailingStopMode = true;

extern color clOpenBuy = Blue;
extern color clCloseBuy = Aqua;
extern color clOpenSell = Red;
extern color clCloseSell = Violet;
extern color clModiBuy = Blue;
extern color clModiSell = Red;


double AccStartEquity=0;
int    Magic;
int IsPosition=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
   Magic = Period()+777;
   return(0);
  }
  
  
//+------------------------------------------------------------------+
//|     Start of the EA Heder                                        |
//+------------------------------------------------------------------+
int start()
  {
  
   double fma,sma,pfma,psma;
   
   psma=  iMA(NULL,PERIOD_H1,SlowMA,0,MODE_EMA,PRICE_CLOSE,1); 
   pfma=  iMA(NULL,PERIOD_H1,FastMA,0,MODE_EMA,PRICE_CLOSE,1);
   
   sma=  iMA(NULL,PERIOD_H1,SlowMA,0,MODE_EMA,PRICE_CLOSE,0); 
   fma=  iMA(NULL,PERIOD_H1,FastMA,0,MODE_EMA,PRICE_CLOSE,0);
   
   
   int total=OrdersTotal();
   if(total<1) 
     {
      // no opened orders identified
      if(AccountFreeMargin()<(1000*Lots))
        {
         Print("We have no money. Free Margin = ", AccountFreeMargin());
         return(0);  
        }
        
      // check for long position (BUY) possibility
      if(fma>sma+(Shift*Point) && fma-pfma>0)   fBuy();
       
      // check for short position (SELL) possibility
      if(fma<sma-(Shift*Point) && fma-pfma<0)   fSell();
     }
  
   for(int cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   // check for opened position 
         OrderSymbol()==Symbol())  // check for symbol
        {
         if(OrderType()==OP_BUY)   // long position is opened
           {
            // should it be closed?
            if(fma<sma-(Shift*Point) && fma-pfma<0)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
           }
         else // go to short position
           {
            // should it be closed?
            if(fma>sma+(Shift*Point) && fma-pfma>0)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            
           }
        }
     }
      
      
    if (TrailingStopMode == true) fTrailStop();
     
   return(0);
  }
// ***** End of Main Loop ******


//+------------------------------------------------------------------+
//| Check Trailing Stop                                              |
//+------------------------------------------------------------------+
void fTrailStop()
{
   for (int i=0; i<OrdersTotal(); i++) 
   { 
      if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) 
      { 
         if (OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) 
         {
            if (OrderType()==OP_BUY) 
            { 
               if (Bid-OrderOpenPrice()>TrailingStop*Point) 
               { 
                  if (OrderStopLoss()<Bid-TrailingStop*Point) 
                     fModifyStopLoss(Bid-TrailingStop*Point); 
               }
            }
            if (OrderType()==OP_SELL)
            {
               if (OrderOpenPrice()-Ask>TrailingStop*Point) 
               {
                  if (OrderStopLoss()>Ask+TrailingStop*Point || OrderStopLoss()==0)  
                     fModifyStopLoss(Ask+TrailingStop*Point); 
               }
                   
            } 
         } 
      } 
    } 
}

//+------------------------------------------------------------------+
//| Modify Stop Loss                                                 |
//+------------------------------------------------------------------+
void fModifyStopLoss(double tStopLoss) 
{ 
   bool result = OrderModify(OrderTicket(),OrderOpenPrice(),tStopLoss,OrderTakeProfit(),0,clCloseSell); 
}

//+------------------------------------------------------------------+
//| Buy                                                              |
//+------------------------------------------------------------------+
void fBuy()
{
   int result =OrderSend(Symbol(),OP_BUY,Lots,Ask,Slippage,Ask-StopLoss*Point,Ask+TakeProfit*Point,NULL,Magic,0,clOpenBuy); 
}

//+------------------------------------------------------------------+
//| Sell                                                             |
//+------------------------------------------------------------------+
void fSell()
{
   int result =OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,Bid+StopLoss*Point,Bid-TakeProfit*Point,NULL,Magic,0,clOpenSell); 
}